/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 01 de Septiembre de 2001

Simulacin:  AlgEvo005
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Hay un Universo
Universo tiene ambientes
Universo tiene tipos de materiales
Hay materiales de cada tipo dispersos por todo el Universo
El ser vivo es la cooperacin entre materiales
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Ambiente.h"
#include "Mutacion.h"


/* Constructor */
Ambiente::Ambiente()
{
	unsigned int iCont;
	for (iCont=0; iCont<200; iCont++)
		m_sEcuacion[iCont]='\0';
};

/* Inicializa los ambientes */
unsigned int Ambiente::iInicia(unsigned int iID,
								unsigned int iXmin, unsigned int iYmin, unsigned int iXmax, unsigned int iYmax,
								unsigned int iLongExpr,
								unsigned int iProbN, unsigned int iProbX, unsigned int iProbY, unsigned int iProbP)
{
	/* Valida MAXIMALONGEXPRESION */
	if (iLongExpr >= MAXIMALONGEXPRESION )
		return EXCEDIOLIMITES;

	/* Identifica el ambiente con un cdigo */
	m_iIDambiente = iID;

	/* Inicializa los extremos del ambiente rectngular */
	m_iXini = 0;
	m_iXfin = 0;
	m_iYini = 0;
	m_iYfin = 0;

	/* Tamao rectangular de cada ambiente */
	do{
		m_iXini = rand() % (iXmax - iXmin) + iXmin;
		m_iXfin = rand() % (iXmax - iXmin) + iXmin;
	}while ( m_iXini >= m_iXfin );

	do{
		m_iYini = rand() % (iYmax - iYmin) + iYmin;
		m_iYfin = rand() % (iYmax - iYmin) + iYmin;
	}while ( m_iYini >= m_iYfin );

	/* Ecuacin que define el ambiente en f(x,y) */
	Mutacion objMuta;

	objMuta.vIniLista(iProbN, iProbX, iProbY, iProbP);
	objMuta.vCreaExpresion(iProbN, iProbX, iProbY, iProbP, iLongExpr);
	strcpy(m_sEcuacion, objMuta.sExpresion);

	/* Evalua previamente la ecuacin para mayor velocidad */
	objEval.dCapturaEcuacion(m_sEcuacion, (float)0, (float)0);

	return OPERACIONEXITOSA;
};

/* Determina si un punto esta dentro del rea */
unsigned int Ambiente::iDentro(unsigned int iPosX, unsigned int iPosY)
{
	if (iPosX >= m_iXini && iPosX <= m_iXfin && iPosY >= m_iYini && iPosY <= m_iYfin)
		return AMB_DENTRO;
	return AMB_FUERA;
};

/* Determina el valor interno del ambiente en un punto dado */
float Ambiente::fValCoord(unsigned int iPosX, unsigned int iPosY)
{
	if (iDentro(iPosX, iPosY)==AMB_DENTRO)
		return (float) objEval.dCicloEvalua( (float) iPosX, (float) iPosY);
	else
		return (float) 0;
};