/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 01 de Septiembre de 2001

Simulacin:  AlgEvo005
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Hay un Universo
Universo tiene ambientes
Universo tiene tipos de materiales
Hay materiales de cada tipo dispersos por todo el Universo
El ser vivo es la cooperacin entre materiales
Hay tipos de seres vivos (el concepto de especie).

*/

#ifndef PARAMETRO
#include "Parametro.h"
#endif

#ifndef EVALUADOREXPRESIONES
#include "EvalExpr.h"
#endif

/* Esta clase representa un ambiente esttico dentro de un Universo */
class Ambiente
{
private:
    /* Identificador del ambiente */
	unsigned int m_iIDambiente;

	/* Ambiente 2D en forma de rectngulo */
	unsigned int m_iXini, m_iYini;
	unsigned int m_iXfin, m_iYfin;

	/* Ecuacion en F(x,y), que muestra el estado de cada punto dentro del ambiente */
	char m_sEcuacion[200];

	/* Evalua previamente la ecuacin para dar mayor velocidad */
	EvalExpr objEval;

public:
	/* Constructor */
	Ambiente(void);

	/* Inicializa los ambientes */
	unsigned int iInicia(unsigned int iID, unsigned int iXmin, unsigned int iYmin, unsigned int iXmax, unsigned int iYmax, unsigned int iLongExpr, unsigned int iProbN, unsigned int iProbX, unsigned int iProbY, unsigned int iProbP);
	
	/* Determina si un punto esta dentro del rea */
	unsigned int iDentro(unsigned int iPosX, unsigned int iPosY);

	/* Determina el valor interno del ambiente en un punto dado */
	float fValCoord(unsigned int iPosX, unsigned int iPosY);
};
