/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 01 de Septiembre de 2001

Simulacin:  AlgEvo005
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Hay un Universo
Universo tiene ambientes
Universo tiene tipos de materiales
Hay materiales de cada tipo dispersos por todo el Universo
El ser vivo es la cooperacin entre materiales

*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "TipoMat.h"
#include "Mutacion.h"

/* Constructor */
TipoMat::TipoMat()
{
	unsigned int iCont;
	for (iCont=0; iCont<200; iCont++)
		m_sEcuacion[iCont]='\0';
};

unsigned int TipoMat::iInicia(unsigned int iID,
					unsigned int iLongExprTip,
					unsigned int iProbN, unsigned int iProbX, unsigned int iProbP,
					unsigned int iTotalTip)
{
	/* Valida MAXIMALONGEXPRESION */
	if (iLongExprTip >= MAXIMALONGEXPRESION )
		return EXCEDIOLIMITES;

	/* ID del tipo de material */
	m_iIDtipo = iID;
	
	/* Ecuacin que define el comportamiento del tipo de material f(x) */
	Mutacion objMuta;

	objMuta.vIniLista(iProbN,iProbX,0,iProbP);
	objMuta.vCreaExpresion(iProbN,iProbX,0,iProbP,iLongExprTip);
	strcpy(m_sEcuacion, objMuta.sExpresion);

	/* Evalua la expresin previamente para mayor velocidad */
	objEval.dCapturaEcuacion(m_sEcuacion, (float) 0, (float) 0);

	/* Crea las tolerancias */
	do
	{
	m_iToleranciaMinima = rand()%10000;
	m_iToleranciaMaxima = rand()%10000;
	}while (m_iToleranciaMinima > m_iToleranciaMaxima);

	/* En que se convierte el material cuando se rebasan los lmites */
	do
	{
		m_iNuevoMatTolMin = rand()%iTotalTip; //Si se pasa del nivel bajo
	}while (m_iNuevoMatTolMin == m_iIDtipo);

	do
	{
		m_iNuevoMatTolMax = rand()%iTotalTip; //Si se pasa del nivel alto
	}while (m_iNuevoMatTolMax == m_iIDtipo);


	return OPERACIONEXITOSA;

};

/* Suma o resta energa dependiendo de como es el ambiente */
signed int TipoMat::iEnergia(float fValAmbiente)
{
	float fResult = objEval.dCicloEvalua(fValAmbiente, (float) 0);

	if (fResult <= 0 )
		return -1;
	else
		return 1;
};

/* Procesa el cambio de tipo de material dependiendo del ambiente */
void TipoMat::vCambio(float fValAmbiente, signed int *iNuevoTipoMat)
{
	float fResult = objEval.dCicloEvalua(fValAmbiente, (float) 0);

	*iNuevoTipoMat = -1;
	if (fResult > m_iToleranciaMaxima) *iNuevoTipoMat = m_iNuevoMatTolMax;
	if (fResult < m_iToleranciaMinima) *iNuevoTipoMat = m_iNuevoMatTolMin;
};
